# HyperV KVP daemon name
%global hv_kvp_daemon hv_kvp_daemon

Name:     hypervkvpd
Version:  0
Release:  0.7%{?dist}
Summary:  HyperV key value pair (KVP) daemon

Group:    System Environment/Daemons
License:  GPLv2
URL:      http://www.kernel.org
# Source file obtained from Microsoft associate via e-mail.
Source0:  %{hv_kvp_daemon}.c
Source1:  hypervkvpd

BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
# because on other Architectures there is no kernel-devel package
ExclusiveArch:    x86_64 i686 ia64 ppc64 s390x
BuildRequires:    kernel-devel >= 2.6.18-336
Requires(post):   chkconfig
Requires(preun):  chkconfig
# This is for /sbin/service
Requires(preun):  initscripts
Requires(postun): initscripts

%description
Hypervkvpd is an implementation of HyperV key value pair (KVP) 
functionality for Linux.

%prep
%setup -Tc
cp -pvL %{SOURCE0} %{hv_kvp_daemon}.c
cp -pvL %{SOURCE1} hypervkvpd

%build
# kernel-devel version
%{!?kversion: %global kversion `ls %{_usrsrc}/kernels | sort -dr | head -n 1`}

gcc \
    %{optflags} \
    -I%{_usrsrc}/kernels/%{kversion}/include \
    %{hv_kvp_daemon}.c \
    -o %{hv_kvp_daemon}

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_sbindir}
install -p -m 0755 %{hv_kvp_daemon} %{buildroot}%{_sbindir}
mkdir -p %{buildroot}%{_initrddir}
# SysV init script
install -p -m 0755 %{SOURCE1} %{buildroot}%{_initrddir}

%post
# This adds the proper /etc/rc*.d links for the script
/sbin/chkconfig --add hypervkvpd

%preun
# Removing package
if [ $1 -eq 0 ] ; then
    /sbin/service hypervkvpd stop >/dev/null 2>&1
    /sbin/chkconfig --del hypervkvpd
fi

%postun
# Updating package
if [ "$1" -ge "1" ] ; then
    /sbin/service hypervkvpd condrestart >/dev/null 2>&1 || :
fi

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc
%{_sbindir}/%{hv_kvp_daemon}
%{_initrddir}/hypervkvpd

%changelog
* Thu Sep 06 2012 Tomas Hozza <thozza@redhat.com> - 0-0.7
- New daemon source obtained from Jason Wang <jasowang@redhat.com>.
  (#854143)

* Mon Sep 03 2012 Tomas Hozza <thozza@redhat.com> - 0-0.6
- rh_status() function in the initscript now explicitly
  returns variable RETVAL value. (#853892)

* Tue Aug 28 2012 Tomas Hozza <thozza@redhat.com> - 0-0.5
- Package is now built also for i686.

* Fri Aug 24 2012 Tomas Hozza <thozza@redhat.com> - 0-0.4
- Added comment for SOURCE0 explaining how it was obtained.

* Thu Aug 23 2012 Tomas Hozza <thozza@redhat.com> - 0-0.3
- Changed path extraction for kernel-devel headers.

* Wed Aug 22 2012 Tomas Hozza <thozza@redhat.com> - 0-0.2
- Added several missing macros to SPEC file.

* Fri Aug 10 2012 Tomas Hozza <thozza@redhat.com> - 0-0.1
- Initial spec file
